Bug 1483300 (deepin-qt5integration) - Review Request: deepin-qt5integration - Qt platform theme integration plugins for DDE
Summary: Review Request: deepin-qt5integration - Qt platform theme integration plugins...
Keywords:
Status: CLOSED RAWHIDE
Alias: deepin-qt5integration
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: DeepinDEPackageReview
TreeView+ depends on / blocked
 
Reported: 2017-08-20 08:46 UTC by sensor.wen
Modified: 2018-07-22 13:32 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-07-22 13:32:15 UTC
Type: Bug
zebob.m: fedora-review+


Attachments (Terms of Use)

Description sensor.wen 2017-08-20 08:46:33 UTC
Spec: https://raw.githubusercontent.com/FZUG/repo/master/rpms/deepin_project/deepin-qt5integration.spec

Description: Qt platform theme integration plugins for DDE

Fedora Account System Username: mosquito

Comment 1 Robert-André Mauchin 🐧 2017-08-20 15:29:02 UTC
Hello,

You need to post both the SPEC URL: and the SRPM URL.

You should use pkg config for your BR. Here is the full list:

BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  pkgconfig(dtkbase)
BuildRequires:  pkgconfig(egl)
BuildRequires:  pkgconfig(gl)
BuildRequires:  pkgconfig(Qt5OpenGLExtensions)
BuildRequires:  pkgconfig(Qt5Svg)
BuildRequires:  pkgconfig(Qt5X11Extras)
BuildRequires:  pkgconfig(Qt5Xdg)
BuildRequires:  pkgconfig(ice)
BuildRequires:  pkgconfig(sm)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xext)
BuildRequires:  pkgconfig(xi)
BuildRequires:  pkgconfig(xrender)
BuildRequires:  pkgconfig(atk)
BuildRequires:  pkgconfig(cairo)
BuildRequires:  pkgconfig(fontconfig)
BuildRequires:  pkgconfig(freetype2)
BuildRequires:  pkgconfig(gtk+-2.0)
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(gdk-pixbuf-2.0)
BuildRequires:  pkgconfig(libinput)
BuildRequires:  pkgconfig(mtdev)
BuildRequires:  pkgconfig(pango)
BuildRequires:  pkgconfig(xcb-ewmh)
BuildRequires:  pkgconfig(xcb-image)
BuildRequires:  pkgconfig(xcb-keysyms)
BuildRequires:  pkgconfig(xcb-renderutil)
BuildRequires:  pkgconfig(xcb)
BuildRequires:  pkgconfig(xkbcommon-x11)
BuildRequires:  pkgconfig(xkbcommon)

 - You need to package the latest version, which is 0.2.3, not 0.2.1.

 - The version in your changelog is wront, you don't need .git2cd7432 if you're packaging a stable release, it's only for development snapshot.

 - I don't get why you define two times the same variable under different names:
%global project qt5integration
%global repo %{project}

  Just keep: %global repo qt5integration

 - There are parts of the code which are not under GPLv3:

BSD (3 clause)
--------------
qt5integration-0.2.3/styles/main.cpp
qt5integration-0.2.3/styles/norwegianwoodstyle.cpp
qt5integration-0.2.3/styles/norwegianwoodstyle.h
qt5integration-0.2.3/styles/widgetgallery.cpp
qt5integration-0.2.3/styles/widgetgallery.h

GPL (v3 or later)
-----------------
qt5integration-0.2.3/dstyleplugin/colorutils.cpp
qt5integration-0.2.3/dstyleplugin/colorutils.h
qt5integration-0.2.3/dstyleplugin/comboboxhelper.cpp
qt5integration-0.2.3/dstyleplugin/common.h
qt5integration-0.2.3/dstyleplugin/commonhelper.cpp
qt5integration-0.2.3/dstyleplugin/commonhelper.h
qt5integration-0.2.3/dstyleplugin/dstyleplugin.cpp
qt5integration-0.2.3/dstyleplugin/dstyleplugin.h
qt5integration-0.2.3/dstyleplugin/framehelper.cpp
qt5integration-0.2.3/dstyleplugin/geometryutils.cpp
qt5integration-0.2.3/dstyleplugin/geometryutils.h
qt5integration-0.2.3/dstyleplugin/lineedithelper.cpp
qt5integration-0.2.3/dstyleplugin/paletteextended.cpp
qt5integration-0.2.3/dstyleplugin/paletteextended.h
qt5integration-0.2.3/dstyleplugin/progressbarhelper.cpp
qt5integration-0.2.3/dstyleplugin/pushbuttonhelper.cpp
qt5integration-0.2.3/dstyleplugin/sliderhelper.cpp
qt5integration-0.2.3/dstyleplugin/style.cpp
qt5integration-0.2.3/dstyleplugin/style.h
qt5integration-0.2.3/platformplugin/dforeignplatformwindow.h
qt5integration-0.2.3/platformplugin/dforeignplatformwindow_x11.cpp
qt5integration-0.2.3/platformplugin/dframewindow.cpp
qt5integration-0.2.3/platformplugin/dframewindow.h
qt5integration-0.2.3/platformplugin/dplatformbackingstorehelper.cpp
qt5integration-0.2.3/platformplugin/dplatformbackingstorehelper.h
qt5integration-0.2.3/platformplugin/dplatformopenglcontexthelper.cpp
qt5integration-0.2.3/platformplugin/dplatformopenglcontexthelper.h
qt5integration-0.2.3/platformplugin/dplatformwindowhelper.cpp
qt5integration-0.2.3/platformplugin/dplatformwindowhelper.h
qt5integration-0.2.3/platformplugin/dwmsupport.h
qt5integration-0.2.3/platformplugin/windoweventhook.cpp
qt5integration-0.2.3/platformplugin/windoweventhook.h

LGPL (v2.1 or v3)
-----------------
qt5integration-0.2.3/dstyleplugin/dstyleanimation.cpp
qt5integration-0.2.3/dstyleplugin/dstyleanimation.h
qt5integration-0.2.3/platformplugin/main.cpp

MIT/X11 (BSD like)
------------------
qt5integration-0.2.3/platformplugin/LICENSE


Please add them in the Licence: tag and add a comment detailing which licenses cover which parts of the code.


 - During the build of your package, it requires an Internet access to git clone a repository. You won't be able to do this on Koji because networking is disabled, you'll get the following error:

Checking for dtkwidget... Cloning into 'libqt5xcbqpa-dev'...
fatal: unable to access 'https://cr.deepin.io/libqt5xcbqpa-dev/': Could not resolve host: cr.deepin.io
Project ERROR: clone libqt5xcbqpa header sources failed

 So you must find an alternate solution to include libqt5xcbqpa. I suggest you to add this repository in a tar.gz as Source1, with detailed instruction on how you build the tar.gz:

# git clone https://cr.deepin.io/libqt5xcbqpa-dev/
# tar -cf libqt5xcbqpa-dev.tar.gz libqt5xcbqpa-dev
Source1:        libqt5xcbqpa-dev.tar.gz

 Then in %prep, after %setup, you just unpack the tar.gz and move it where the build script expects it:

%{__tar} xf %{SOURCE1}
%{__mv} libqt5xcbqpa-dev platformplugin/.

 With this, you'll be able to build it in Koji later.

Comment 3 Robert-André Mauchin 🐧 2017-08-29 11:05:39 UTC
You didn't seem to have fixed the following:

 - During the build of your package, it requires an Internet access to git clone a repository. You won't be able to do this on Koji because networking is disabled, you'll get the following error:

Checking for dtkwidget... Cloning into 'libqt5xcbqpa-dev'...
fatal: unable to access 'https://cr.deepin.io/libqt5xcbqpa-dev/': Could not resolve host: cr.deepin.io
Project ERROR: clone libqt5xcbqpa header sources failed

 So you must find an alternate solution to include libqt5xcbqpa. I suggest you to add this repository in a tar.gz as Source2, with detailed instruction on how you build the tar.gz:

# git clone https://cr.deepin.io/libqt5xcbqpa-dev/
# tar -cf libqt5xcbqpa-dev.tar.gz libqt5xcbqpa-dev
Source2:        libqt5xcbqpa-dev.tar.gz

 Then in %prep, after %setup, you just unpack the tar.gz and move it where the build script expects it:

%{__tar} xf %{SOURCE1}
%{__mv} libqt5xcbqpa-dev platformplugin/.


If you don't you won't be able to buid it in Koji.

Comment 4 sensor.wen 2017-08-29 11:17:18 UTC
:)    I fixed and add the qtbase source code tarball (Source1).

Comment 5 sensor.wen 2017-08-31 16:48:39 UTC
https://github.com/FZUG/repo/commit/f4cca85eb56e212e0bd06209d3e8441e28752c05#diff-99d348d0d124eb6f7450adb1db4e0e31R55

I added to include libqt5xcbqpa header files in spec. It looks like good.

Comment 6 Robert-André Mauchin 🐧 2017-09-01 07:06:35 UTC
This package depends on Deepin File Manager, which I can't build because it depends on ffmpegthumbnailer, only  available on rpmfusion. You need to find a solution for this, either patch it to remove the ffmpegthumbnailer dependency or find something else.

Comment 8 Robert-André Mauchin 🐧 2017-09-01 09:00:39 UTC
You download the source of qtbase in version 5.7.1 but here:

cp qtbase-opensource-src-%{_qt5_version}/src/plugins/platforms/xcb/*.h \
  platformplugin/libqt5xcbqpa-dev/

you use %{_qt5_version} which is not always 5.7.1: on Rawhide it replaces %{_qt5_version} with 5.9.1 so it can't work.

I think you should download the qtbase 5.9.1 instead of 5.7.1 and not use %{_qt5_version}

Comment 10 Robert-André Mauchin 🐧 2017-09-01 17:02:05 UTC
It looks good, package accepted.


===== MUST items =====

C/C++:
[ ]: Package does not contain kernel modules.
[ ]: Package contains no static executables.
[ ]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (2 clause) GPL (v3) LGPL (v3)", "*No copyright* MPL
     (v2.0)", "BSD (3 clause)", "LGPL (v2.1)", "*No copyright* MIT/X11 (BSD
     like)", "*No copyright* Apache (v2.0)", "Public domain", "Freetype",
     "GPL (v3 or later)", "zlib/libpng", "*No copyright* MIT (old)",
     "MIT/X11 (BSD like)", "BSD (2 clause)", "BSD (unspecified) CC0
     (v1.0)", "MIT (old)", "Apache (v2.0)", "MPL (v1.1) GPL (v2 or later)
     or LGPL (v2.1 or later)", "*No copyright* zlib/libpng", "*No
     copyright* Public domain", "MIT (enna) BSD (2 clause)", "*No
     copyright* BSD (unspecified)", "BSD (unspecified)", "LGPL (v3)", "BSD
     (3 clause) GPL (v2)", "Freetype GPL (v3) LGPL (v3)", "GPL (v3)", "GPL
     (v3) LGPL (v3)", "Unknown or generated", "Freetype Public domain",
     "*No copyright* CDDL", "LGPL (v2.1 or v3)", "NTP (legal disclaimer)".
     15649 files have unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/deepin-qt5integration/review-deepin-
     qt5integration/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: Package does not own files or directories owned by other packages.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in deepin-
     qt5integration-debuginfo
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: deepin-qt5integration-0.2.3-1.fc28.x86_64.rpm
          deepin-qt5integration-debuginfo-0.2.3-1.fc28.x86_64.rpm
          deepin-qt5integration-0.2.3-1.fc28.src.rpm
deepin-qt5integration.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
deepin-qt5integration.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
3 packages and 0 specfiles checked; 0 errors, 2 warnings.

Comment 11 Gwyn Ciesla 2017-09-04 18:06:57 UTC
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/deepin-qt5integration

Comment 12 Zamir SUN 2018-07-22 13:32:15 UTC
This is already in Rawhide. Closing on behalf of the Deepin Desktop packaging effort.


Note You need to log in before you can comment on or make changes to this bug.